



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>FFmpeg 入门(4)：线程分治</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">FFmpeg 入门(4)：线程分治</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 07:32:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文转自：<a href="http://www.samirchen.com/ffmpeg-tutorial-4" rel="external nofollow noreferrer">FFmpeg 入门(4)：线程分治 | www.samirchen.com</a></p>
<h2>概览</h2>
<p>上一节教程中，我们使用 SDL 的音频相关的函数来支持音频播放。SDL 起了一个线程来在需要音频数据的时候去调用我们定义的回调方法。现在我们要做的是用线程的方法去改造视频显示这块的逻辑。这样一来会使得代码的机构更模块化，这样改动起来会更简单，尤其是当我们想添加音视频同步逻辑时。</p>
<p>我们从哪开始呢？首先，我们发现我们的 main 函数做的事情太多了：运行 event loop、读取数据包、进行视频解码等等，所以我们现在要做的就是把这些事情拆分掉：一个线程来专门做数据包解码，这些数据包会被添加到队列中，并分别被音频处理线程和视频处理线程来读取和处理。音频处理线程我们在上一节已经按照设想写好了，视频处理线程要复杂一些，因为我们需要自己来显示视频。我们要把显示视频的代码放到 main loop，但是不会每次循环的时候去做显示，而是把视频显示集成 event loop 中去。方式就是解码视频数据，把视频帧存到另一个队列，然后创建一个自定义事件(FF_REFRESH_EVENT)添加到事件系统，然后当 event loop 处理这个事件时就会显示队列中的下一帧。下面我们用个图来说明下这个流程：</p>
<pre class="prettyprint linenums"><code> ________ audio  _______      _____<br />
|        | pkts |       |    |     | to speaker.<br />
| DECODE |-----&gt;| AUDIO |---&gt;| SDL |--&gt;<br />
|________|      |_______|    |_____|<br />
    |  video     _______<br />
    |   pkts    |       |<br />
    +----------&gt;| VIDEO |<br />
 ________       |_______|   _______<br />
|       |          |       |       |<br />
| EVENT |          +------&gt;| VIDEO | to monitor.<br />
| LOOP  |-----------------&gt;| DISP. |--&gt;<br />
|_______|&lt;---FF_REFRESH----|_______|<br />
</code></pre>
<p>把视频显示的逻辑放到 event loop 中去的主要目的是为了使用 <code>SDL_Delay</code> 线程，这样我们可以准确的控制下一个视频帧什么时候显示到屏幕上。在下一节教程中当我们要做音视频同步时，相关的逻辑就会变得简单些了。</p>
<h2>精简代码</h2>
<p>我们现在要创建一个比较大的结构体来容纳所有音视频信息，叫做 <code>VideoState</code>。</p>
<pre class="prettyprint linenums"><code>typedef struct VideoState {<br />
	AVFormatContext *pFormatCtx;<br />
	int videoStream, audioStream;<br />
	AVStream *audio_st;<br />
	PacketQueue audioq;<br />
	uint8_t audio_buf[(MAX_AUDIO_FRAME_SIZE * 3) / 2];<br />
	unsigned int audio_buf_size;<br />
	unsigned int audio_buf_index;<br />
	AVFrame audio_frame;<br />
	AVPacket audio_pkt;<br />
	uint8_t *audio_pkt_data;<br />
	int audio_pkt_size;<br />
	AVStream *video_st;<br />
	PacketQueue videoq;

	VideoPicture pictq[VIDEO_PICTURE_QUEUE_SIZE];<br />
	int pictq_size, pictq_rindex, pictq_windex;<br />
	SDL_mutex *pictq_mutex;<br />
	SDL_cond *pictq_cond;

	SDL_Thread *parse_tid;<br />
	SDL_Thread *video_tid;

	char filename[1024];<br />
	int quit;

	AVIOContext *io_context;<br />
	struct SwsContext *sws_ctx;<br />
} VideoState;<br />
</code></pre>
<p>简单看看 <code>VideoState</code> 中都有什么。首先，格式信息 <code>pFormatCtx</code>；视频和音频流的标记 <code>videoStream</code>、<code>audioStream</code>，以及对应的视频和音频流对象 <code>audio_st</code>、<code>video_st</code>；接下来，是我们移过来的音频缓冲区相关的数据：<code>audio_buf</code>、<code>audio_buf_size</code>、<code>audio_buf_index</code> 等；我们还添加了视频数据队列 <code>videoq</code>、视频数据缓冲区 <code>pictq</code> 来存储解码后的视频帧，<code>VideoPicture</code> 是我们自己创建的数据结构，我们后面再看里面都有些啥；我们还增加了两个指向对应线程的指针：<code>parse_tid</code>、<code>video_tid</code>；此外还有退出标志 <code>quit</code>，媒体文件名 <code>filename</code> 等等。</p>
<p>现在我们回到 main 函数来看看我们的程序都有哪些改变。首先，我们创建 <code>VideoState</code> 并分配内存：</p>
<pre class="prettyprint linenums"><code>int main(int argc, char *argv[]) {<br />
	SDL_Event event;<br />
	VideoState *is;<br />
	is = av_mallocz(sizeof(VideoState));<br />
	// ... code ...<br />
}<br />
</code></pre>
<p><code>av_mallocz()</code> 会为我们分配内存并将内存初始化为 0。</p>
<p>接着，初始化视频渲染相关数据缓冲区 <code>pictq</code> 的锁。因为事件循环调用我们的渲染函数时，渲染逻辑就会从 <code>pictq</code> 获取数据，同时解码逻辑又会往 <code>pictq</code> 写入数据，我们不知道谁会先到，所以这里需要通过锁机制来防止线程错乱。同时，我们这里把媒体文件路径也拷贝到 <code>VideoState</code> 中。</p>
<pre class="prettyprint linenums"><code>av_strlcpy(is-&gt;filename, argv[1], sizeof(is-&gt;filename));

is-&gt;pictq_mutex = SDL_CreateMutex();<br />
is-&gt;pictq_cond = SDL_CreateCond();<br />
</code></pre>
<p><code>av_strlcpy</code> 是 FFmpeg 基于 <code>strncpy</code> 提供的一个字符串拷贝方法，增加了一些边界检查功能。</p>
<h2>第一个线程</h2>
<p>现在我们启动 <code>decode_thread()</code> 线程来开始工作：</p>
<pre class="prettyprint linenums"><code>schedule_refresh(is, 40);

is-&gt;parse_tid = SDL_CreateThread(decode_thread, is);<br />
if (!is-&gt;parse_tid) {<br />
	av_free(is);<br />
	return -1;<br />
}<br />
</code></pre>
<p>我们将在后面实现 <code>schedule_refresh()</code> 函数，它的主要功能就是告诉系统在指定的延时后来推送一个 <code>FF_REFRESH_EVENT</code> 事件。这个事件将在事件队列里触发 video refresh 函数的调用。不过，现在我们还是先来看看 <code>SDL_CreateThread()</code> 函数。</p>
<p><code>SDL_CreateThread()</code> 函数会分发一个新的线程，这个线程有原进程的所有内存的访问权限，并从我们指定的函数开始运行。这个线程会给指定的函数传入一个用户定义的数据作为参数，在我们这里，我们调用的函数是 <code>decode_thread()</code> 传入的参数是前面初始化的 <code>VideoState</code>。<code>decode_thread()</code> 的前半部分没有什么新鲜的：打开媒体文件找到视频流和音频流的索引。这里与之前唯一的不同就是 <code>AVFormatContext</code> 被我们放到 <code>VideoState</code> 中去了。在找到了视频流和音频流后，我们接下来就调用另一个我们将实现的函数: <code>stream_component_open()</code>。这里我们就将代码模块化了，对重复的工作完成了一些代码复用。</p>
<p><code>stream_component_open()</code> 函数主要用于帮我们找到对应的解码器、创建对应的音频配置、保存关键信息到 <code>VideoState</code>、启动音频和视频线程。这个函数也是我们添加其他配置的地方，比如强制使用给定的 codec 而不是自动检测等等。代码如下：</p>
<pre class="prettyprint linenums"><code>int stream_component_open(VideoState *is, int stream_index) {

	AVFormatContext *pFormatCtx = is-&gt;pFormatCtx;<br />
	AVCodecContext *codecCtx = NULL;<br />
	AVCodec *codec = NULL;<br />
	AVDictionary *optionsDict = NULL;<br />
	SDL_AudioSpec wanted_spec, spec;

	if (stream_index &lt; 0 || stream_index &gt;= pFormatCtx-&gt;nb_streams) {<br />
		return -1;<br />
	}

	// Get a pointer to the codec context for the video stream.<br />
	codecCtx = pFormatCtx-&gt;streams[stream_index]-&gt;codec;

	if (codecCtx-&gt;codec_type == AVMEDIA_TYPE_AUDIO) {<br />
		// Set audio settings from codec info.<br />
		wanted_spec.freq = codecCtx-&gt;sample_rate;<br />
		wanted_spec.format = AUDIO_S16SYS;<br />
		wanted_spec.channels = codecCtx-&gt;channels;<br />
		wanted_spec.silence = 0;<br />
		wanted_spec.samples = SDL_AUDIO_BUFFER_SIZE;<br />
		wanted_spec.callback = audio_callback;<br />
		wanted_spec.userdata = is;

		if (SDL_OpenAudio(&amp;wanted_spec, &amp;spec) &lt; 0) {<br />
			fprintf(stderr, &quot;SDL_OpenAudio: %s\n&quot;, SDL_GetError());<br />
			return -1;<br />
		}<br />
	}<br />
	codec = avcodec_find_decoder(codecCtx-&gt;codec_id);<br />
	if (!codec || (avcodec_open2(codecCtx, codec, &amp;optionsDict) &lt; 0)) {<br />
		fprintf(stderr, &quot;Unsupported codec!\n&quot;);<br />
		return -1;<br />
	}

	switch(codecCtx-&gt;codec_type) {<br />
		case AVMEDIA_TYPE_AUDIO:<br />
			is-&gt;audioStream = stream_index;<br />
			is-&gt;audio_st = pFormatCtx-&gt;streams[stream_index];<br />
			is-&gt;audio_buf_size = 0;<br />
			is-&gt;audio_buf_index = 0;<br />
			memset(&amp;is-&gt;audio_pkt, 0, sizeof(is-&gt;audio_pkt));<br />
			packet_queue_init(&amp;is-&gt;audioq);<br />
			SDL_PauseAudio(0);<br />
			break;<br />
		case AVMEDIA_TYPE_VIDEO:<br />
			is-&gt;videoStream = stream_index;<br />
			is-&gt;video_st = pFormatCtx-&gt;streams[stream_index];

			packet_queue_init(&amp;is-&gt;videoq);<br />
			is-&gt;video_tid = SDL_CreateThread(video_thread, is);<br />
			is-&gt;sws_ctx = sws_getContext(is-&gt;video_st-&gt;codec-&gt;width, is-&gt;video_st-&gt;codec-&gt;height, is-&gt;video_st-&gt;codec-&gt;pix_fmt, is-&gt;video_st-&gt;codec-&gt;width, is-&gt;video_st-&gt;codec-&gt;height, AV_PIX_FMT_YUV420P, SWS_BILINEAR, NULL, NULL, NULL);<br />
			break;<br />
		default:<br />
			break;<br />
	}<br />
	return 0;<br />
}<br />
</code></pre>
<p>上面的函数主要是服务于音频和视频，这里把 <code>VideoState</code> 作为回调函数的参数数据。同时，我们保存了 <code>audio_st</code> 和 <code>video_st</code>，还初始化了视频队列 <code>videoq</code> 和音频队列 <code>audioq</code>。最重要的是，我们在这里启动了音频线程和视频线程。</p>
<pre class="prettyprint linenums"><code>SDL_PauseAudio(0);<br />
break;

// ...... 

is-&gt;video_tid = SDL_CreateThread(video_thread, is);<br />
</code></pre>
<p>我们接着看看 <code>decode_thread()</code> 的后半部分，这部分的主要工作是通过一个循环来读取 packet 并把它放入正确的队列：</p>
<pre class="prettyprint linenums"><code>int decode_thread(void *arg) {

	// ... code ...

	// Main decode loop.<br />
	for (;;) {<br />
		if (is-&gt;quit) {<br />
			break;<br />
		}<br />
		// Seek stuff goes here.<br />
		if (is-&gt;audioq.size &gt; MAX_AUDIOQ_SIZE || is-&gt;videoq.size &gt; MAX_VIDEOQ_SIZE) {<br />
			SDL_Delay(10);<br />
			continue;<br />
		}<br />
		if (av_read_frame(is-&gt;pFormatCtx, packet) &lt; 0) {<br />
			if (is-&gt;pFormatCtx-&gt;pb-&gt;error == 0) {<br />
				SDL_Delay(100); // No error; wait for user input.<br />
				continue;<br />
			} else {<br />
				break;<br />
			}<br />
		}<br />
		// Is this a packet from the video stream?<br />
		if (packet-&gt;stream_index == is-&gt;videoStream) {<br />
			packet_queue_put(&amp;is-&gt;videoq, packet);<br />
		} else if (packet-&gt;stream_index == is-&gt;audioStream) {<br />
			packet_queue_put(&amp;is-&gt;audioq, packet);<br />
		} else {<br />
			av_packet_unref(packet);<br />
		}<br />
	}

	// All done - wait for it.<br />
	while (!is-&gt;quit) {<br />
		SDL_Delay(100);<br />
	}

	fail:<br />
	if (1) {<br />
		SDL_Event event;<br />
		event.type = FF_QUIT_EVENT;<br />
		event.user.data1 = is;<br />
		SDL_PushEvent(&amp;event);<br />
	}<br />
	return 0;<br />
}<br />
</code></pre>
<p>上面代码的 for 循环中，我们为音频队列和视频队列添加了 max size，还增加了对读数据错误的检查。<code>AVFormatContext *pFormatCtx</code> 有一个 <code>ByteIOContext</code> 成员，这个成员会记录所有底层文件信息。</p>
<p>在循环完成后，接下来的逻辑就是等待其他任务结束，以及发出通知告诉其他任务我们这已经结束了。这段扫尾代码也演示了如何发事件。</p>
<p>我们通过 SDL 提供的常量 <code>SDL_USEREVENT</code> 来取得用户事件，第一个用户事件的值为 <code>SDL_USEREVENT</code>，往后则都是累加 1。比如，<code>FF_QUIT_EVENT</code> 事件在我们的程序中的值是 <code>SDL_USEREVENT + 1</code>。我们还可以给事件附加上用户数据，我们的程序中，我们把用户数据的指针指向了 <code>is</code>。最后我们调用 <code>SDL_PushEvent()</code> 函数将事件发布出去。在后续的事件处理逻辑中，我们将遍历和处理事件。现在要明确的就是我们这里发出了 <code>FF_QUIT_EVENT</code> 事件，我们将获取这个事件并将 <code>quit</code> 标志置为 1。</p>
<h2>获取帧：video_thread</h2>
<p>在 codec 准备好后，我们启动 video thread。这个线程从 video queue 中读取数据包 packet，解码为视频帧，然后调用 <code>queue_picture()</code> 函数将处理好的帧添加到 picture queue。</p>
<pre class="prettyprint linenums"><code>int video_thread(void *arg) {<br />
	VideoState *is = (VideoState *) arg;<br />
	AVPacket pkt1, *packet = &amp;pkt1;<br />
	int frameFinished;<br />
	AVFrame *pFrame;

	pFrame = av_frame_alloc();

	for (;;) {<br />
		if (packet_queue_get(&amp;is-&gt;videoq, packet, 1) &lt; 0) {<br />
			// Means we quit getting packets.<br />
			break;<br />
		}<br />
		// Decode video frame.<br />
		avcodec_decode_video2(is-&gt;video_st-&gt;codec, pFrame, &amp;frameFinished, packet);

		// Did we get a video frame?<br />
		if (frameFinished) {<br />
			if (queue_picture(is, pFrame) &lt; 0) {<br />
				break;<br />
			}<br />
		}<br />
		av_packet_unref(packet);<br />
	}<br />
	av_free(pFrame);<br />
	return 0;<br />
}<br />
</code></pre>
<p>这里的代码还是比较清晰的，我们把 <code>avcodec_decode_video2()</code> 函数挪到了这里，由于很多信息被我们放到了 <code>VideoState</code> 中，所以这里的参数我们做了改变，比如：我们通过 <code>is-&gt;video_st-&gt;codec</code> 从 <code>VideoState</code> 中获取视频的 codec。我们持续从 video queue 中获取 packet 数据包，直到有人告诉我们 quit 或者遇到错误。</p>
<h2>帧队列</h2>
<p>接着，我们看一下存储解码帧的函数 <code>queue_picture()</code>，由于我们的 picture queue 里放的是 SDL overlay，所以我们需要把视频帧转换为 SDL overlay。</p>
<pre class="prettyprint linenums"><code>typedef struct VideoPicture {<br />
	SDL_Overlay *bmp;<br />
	int width, height; // Source height &amp; width..<br />
	int allocated;<br />
} VideoPicture;<br />
</code></pre>
<p><code>VideoState</code> 中有个缓冲区用来存储 <code>VideoPicture</code>，但是我们需要自己创建和分配 <code>SDL_Overlay</code> 的内存，注意，<code>allocated</code> 就是用来标记我们有没有做这件事。</p>
<p>我们需要两个指针来帮助我们使用这个队列：写索引和读索引。我们同时也记录缓冲区有多少图像。当要往队列写入数据时，我们首先要等缓冲区清理出空间来存放 <code>VideoPicture</code>。然后我们检查我们是否在写索引位置创建了 SDL overlay，如果没有则需要分配对应的内存。如果窗口的尺寸发生改变了，我们还要重新创建缓冲区。</p>
<pre class="prettyprint linenums"><code>int queue_picture(VideoState *is, AVFrame *pFrame) {

	VideoPicture *vp;<br />
	AVFrame pict;

	// Wait until we have space for a new pic.<br />
	SDL_LockMutex(is-&gt;pictq_mutex);<br />
	while (is-&gt;pictq_size &gt;= VIDEO_PICTURE_QUEUE_SIZE &amp;&amp; !is-&gt;quit) {<br />
		SDL_CondWait(is-&gt;pictq_cond, is-&gt;pictq_mutex);<br />
	}<br />
	SDL_UnlockMutex(is-&gt;pictq_mutex);

	if (is-&gt;quit) {<br />
		return -1;<br />
	}

	// windex is set to 0 initially.<br />
	vp = &amp;is-&gt;pictq[is-&gt;pictq_windex];

	// Allocate or resize the buffer!<br />
	if (!vp-&gt;bmp || vp-&gt;width != is-&gt;video_st-&gt;codec-&gt;width || vp-&gt;height != is-&gt;video_st-&gt;codec-&gt;height) {<br />
		SDL_Event event;

		vp-&gt;allocated = 0;<br />
		// We have to do it in the main thread.<br />
		event.type = FF_ALLOC_EVENT;<br />
		event.user.data1 = is;<br />
		SDL_PushEvent(&amp;event);

		// Wait until we have a picture allocated.<br />
		SDL_LockMutex(is-&gt;pictq_mutex);<br />
		while (!vp-&gt;allocated &amp;&amp; !is-&gt;quit) {<br />
			SDL_CondWait(is-&gt;pictq_cond, is-&gt;pictq_mutex);<br />
		}<br />
		SDL_UnlockMutex(is-&gt;pictq_mutex);<br />
		if (is-&gt;quit) {<br />
			return -1;<br />
		}<br />
	}

	// ... code ...

}<br />
</code></pre>
<p>这里我们发送了一个事件 <code>FF_ALLOC_EVENT</code>，处理这个事件的代码在主线程中：</p>
<pre class="prettyprint linenums"><code>case FF_ALLOC_EVENT:<br />
	alloc_picture(event.user.data1);<br />
	break;<br />
</code></pre>
<p>这里调用了 <code>alloc_picture()</code> 函数，我们来看一下这个函数：</p>
<pre class="prettyprint linenums"><code>void alloc_picture(void *userdata) {

	VideoState *is = (VideoState *)userdata;<br />
	VideoPicture *vp;

	vp = &amp;is-&gt;pictq[is-&gt;pictq_windex];<br />
	if (vp-&gt;bmp) {<br />
		// We already have one make another, bigger/smaller.<br />
		SDL_FreeYUVOverlay(vp-&gt;bmp);<br />
	}<br />
	// Allocate a place to put our YUV image on that screen.<br />
	SDL_LockMutex(screen_mutex);<br />
	vp-&gt;bmp = SDL_CreateYUVOverlay(is-&gt;video_st-&gt;codec-&gt;width, is-&gt;video_st-&gt;codec-&gt;height, SDL_YV12_OVERLAY, screen);<br />
	SDL_UnlockMutex(screen_mutex);<br />
	vp-&gt;width = is-&gt;video_st-&gt;codec-&gt;width;<br />
	vp-&gt;height = is-&gt;video_st-&gt;codec-&gt;height;

	SDL_LockMutex(is-&gt;pictq_mutex);<br />
	vp-&gt;allocated = 1;<br />
	SDL_CondSignal(is-&gt;pictq_cond);<br />
	SDL_UnlockMutex(is-&gt;pictq_mutex);

}<br />
</code></pre>
<p>我们把 <code>SDL_CreateYUVOverlay()</code> 从 main 函数中移到了这里，现在我们对这个函数加了锁，因为有两个线程可以同时往屏幕写数据，这样能防止 <code>alloc_picture()</code> 函数和显示视频的函数发生冲突。需要注意我们在 <code>VideoPicture</code> 中记录了视频的宽度和高度，因为我们需要确保我们的视频尺寸不会发生改变。</p>
<p>现在我们已经创建了 YUV overlay 并分配了内存，我们做好了接收图像的准备。现在我们回到 <code>queue_picture()</code> 函数来看看拷贝视频帧到 YUV overlay 的这部分代码：</p>
<pre class="prettyprint linenums"><code>int queue_picture(VideoState *is, AVFrame *pFrame) {

	// Allocate a frame if we need it...<br />
	// ... code ...<br />
	// We have a place to put our picture on the queue 

	// We have a place to put our picture on the queue.<br />
	if (vp-&gt;bmp) {

		SDL_LockYUVOverlay(vp-&gt;bmp);

		// Point pict at the queue.<br />
		pict.data[0] = vp-&gt;bmp-&gt;pixels[0];<br />
		pict.data[1] = vp-&gt;bmp-&gt;pixels[2];<br />
		pict.data[2] = vp-&gt;bmp-&gt;pixels[1];

		pict.linesize[0] = vp-&gt;bmp-&gt;pitches[0];<br />
		pict.linesize[1] = vp-&gt;bmp-&gt;pitches[2];<br />
		pict.linesize[2] = vp-&gt;bmp-&gt;pitches[1];

		// Convert the image into YUV format that SDL uses.<br />
		sws_scale(is-&gt;sws_ctx, (uint8_t const * const *)pFrame-&gt;data, pFrame-&gt;linesize, 0, is-&gt;video_st-&gt;codec-&gt;height, pict.data, pict.linesize);

		SDL_UnlockYUVOverlay(vp-&gt;bmp);<br />
		// Now we inform our display thread that we have a pic ready.<br />
		if (++is-&gt;pictq_windex == VIDEO_PICTURE_QUEUE_SIZE) {<br />
			is-&gt;pictq_windex = 0;<br />
		}<br />
		SDL_LockMutex(is-&gt;pictq_mutex);<br />
		is-&gt;pictq_size++;<br />
		SDL_UnlockMutex(is-&gt;pictq_mutex);<br />
	}<br />
	return 0;<br />
}<br />
</code></pre>
<p>这段代码主要是用视频帧来填充 YUV overlay 的逻辑。最后一段代码就是向队列添加数据，这个队列工作的方式就是不断地往里添加数据直到队列满掉，然后不断从中读取数据只要里面还有数据，所以读写操作都会依赖 <code>is-&gt;pictq_size</code> 的值，所以这里我们要给它加锁。我们在这里做的就是，将写指针递增，然后锁住队列并增加它的 size。然后读数据方会知道队列中有数据了，如果队列满了，我们写数据方也会知道。</p>
<h2>显示视频</h2>
<p>上面介绍完了 video thread，我们接下来来看看 <code>schedule_refresh()</code>：</p>
<pre class="prettyprint linenums"><code>// Schedule a video refresh in 'delay' ms.<br />
static void schedule_refresh(VideoState *is, int delay) {<br />
	SDL_AddTimer(delay, sdl_refresh_timer_cb, is);<br />
}<br />
</code></pre>
<p><code>SDL_AddTimer()</code> 是一个 SDL 的函数，用来在指定的时间(ms)后回调用户指定的函数，当然还可以选择带上用户指定的数据。我们将用 <code>schedule_refresh</code> 这个函数来做图像更新：每次我们调用这个函数，它就会设置一个定时器，这个定时器会触发一个事件来让 main 函数的事件处理逻辑去从 picture queue 取得一帧数据来显示出来。</p>
<pre class="prettyprint linenums"><code>static Uint32 sdl_refresh_timer_cb(Uint32 interval, void *opaque) {<br />
	SDL_Event event;<br />
	event.type = FF_REFRESH_EVENT;<br />
	event.user.data1 = opaque;<br />
	SDL_PushEvent(&amp;event);<br />
	return 0; // 0 means stop timer.<br />
}<br />
</code></pre>
<p><code>sdl_refresh_timer_cb()</code> 就是定时器会触发调用的那个用于发事件的函数，<code>FF_REFRESH_EVENT</code> 事件被定义为了 <code>SDL_USEREVENT + 1</code>。主要注意的是当我们在这里返回 0 时，SDL 会停止这个定时器，这样也就停止去调用这个回调了。</p>
<p>既然我们这里发出了 <code>FF_REFRESH_EVENT</code> 事件，那么就需要有地方处理它，这个地方就在 main 函数的 event loop 中：</p>
<pre class="prettyprint linenums"><code>for (;;) {

	SDL_WaitEvent(&amp;event);<br />
	switch(event.type) {

		// ... code ...

		case FF_REFRESH_EVENT:<br />
			video_refresh_timer(event.user.data1);<br />
			break;

		// ... code ...

	}<br />
}<br />
</code></pre>
<p>从这里可以看到，处理这个事件的函数是 <code>video_refresh_timer()</code>：</p>
<pre class="prettyprint linenums"><code>void video_refresh_timer(void *userdata) {

	VideoState *is = (VideoState *)userdata;<br />
	// vp is used in later tutorials for synchronization.<br />
	VideoPicture *vp;

	if (is-&gt;video_st) {<br />
		if (is-&gt;pictq_size == 0) {<br />
			schedule_refresh(is, 1);<br />
		} else {<br />
			vp = &amp;is-&gt;pictq[is-&gt;pictq_rindex];

			// Now, normally here goes a ton of code about timing, etc. we're just going to guess at a delay for now. You can increase and decrease this value and hard code the timing - but I don't suggest that, We'll learn how to do it for real later.<br />
			schedule_refresh(is, 80);

			// Show the picture!<br />
			video_display(is);

			// Update queue for next picture!<br />
			if (++is-&gt;pictq_rindex == VIDEO_PICTURE_QUEUE_SIZE) {<br />
				is-&gt;pictq_rindex = 0;<br />
			}<br />
			SDL_LockMutex(is-&gt;pictq_mutex);<br />
			is-&gt;pictq_size--;<br />
			SDL_CondSignal(is-&gt;pictq_cond);<br />
			SDL_UnlockMutex(is-&gt;pictq_mutex);<br />
		}<br />
	} else {<br />
		schedule_refresh(is, 100);<br />
	}<br />
}<br />
</code></pre>
<p>这是一个比较简单的函数：当 <code>pictq</code> 队列有数据时就取出 <code>VideoPicture</code>，设置显示下一帧图像的 timer，调用 <code>video_display()</code> 来将视频显示出来，增加队列的计数器，更新队列的 size。你可能注意到了，这里我们虽然取出了一个 <code>VideoPicture</code> 但并没有使用它，原因是我们后面会用到。后面我们会用这个 <code>VideoPicture</code> 的时间信息来做音视频同步相关的工作，其中的时间信息将告诉我们该何时显示下一帧图像，我们会把这个时间信息传给 <code>schedule_refresh()</code>。而现在，我们只是简单的传了一个 80。</p>
<p>现在我们要做的最后一件事就是 <code>video_display()</code> 函数：</p>
<pre class="prettyprint linenums"><code>void video_display(VideoState *is) {<br />
	SDL_Rect rect;<br />
	VideoPicture *vp;<br />
	float aspect_ratio;<br />
	int w, h, x, y;

	vp = &amp;is-&gt;pictq[is-&gt;pictq_rindex];<br />
	if (vp-&gt;bmp) {<br />
		if (is-&gt;video_st-&gt;codec-&gt;sample_aspect_ratio.num == 0) {<br />
			aspect_ratio = 0;<br />
		} else {<br />
			aspect_ratio = av_q2d(is-&gt;video_st-&gt;codec-&gt;sample_aspect_ratio) * is-&gt;video_st-&gt;codec-&gt;width / is-&gt;video_st-&gt;codec-&gt;height;<br />
		}<br />
		if (aspect_ratio &lt;= 0.0) {<br />
			aspect_ratio = (float) is-&gt;video_st-&gt;codec-&gt;width / (float) is-&gt;video_st-&gt;codec-&gt;height;<br />
		}<br />
		h = screen-&gt;h;<br />
		w = ((int)rint(h * aspect_ratio)) &amp; -3;<br />
		if (w &gt; screen-&gt;w) {<br />
			w = screen-&gt;w;<br />
			h = ((int)rint(w / aspect_ratio)) &amp; -3;<br />
		}<br />
		x = (screen-&gt;w - w) / 2;<br />
		y = (screen-&gt;h - h) / 2;

		rect.x = x;<br />
		rect.y = y;<br />
		rect.w = w;<br />
		rect.h = h;<br />
		SDL_LockMutex(screen_mutex);<br />
		SDL_DisplayYUVOverlay(vp-&gt;bmp, &amp;rect);<br />
		SDL_UnlockMutex(screen_mutex);<br />
	}<br />
}<br />
</code></pre>
<p>由于我们的屏幕可以是任意尺寸（我们自己设置的是 640x480，但是这个对用户应该是可以改变的），所以我们需要能够动态地计算我们要显示图像的尺寸。首先，我们需要计算出视频的 <strong>aspect ratio</strong>，即宽度和高度的比例(width/height)。但是有一些 codec 有很奇怪的 <strong>sample aspect ration</strong>，即单像素(单采样)的宽高比(width/height)，又由于我们的 <code>AVCodecContext</code> 中的宽度和高度是以像素为单位来表示的，那么这时候 actual aspect ratio 应该是 aspect ratio 乘上 sample aspect ratio。有的 codec 的 aspect ratio 值是 0，这表示的是每个像素的尺寸是 1x1。</p>
<p>接下来，我们放大视频来尽量适配我们的屏幕。代码中的 <code>&amp; -3</code> 位操作可以将数值调整到最接近 4 的倍数，然后我们将视频居中，并调用 <code>SDL_DisplayYUVOverlay()</code>，这里要确保我们通过 <code>screen_mutex</code> 来加锁。</p>
<p>到这里，我们还需要用新的 <code>VideoState</code> 来重写音频处理的代码，但这里的工作还是比较少的，参见样例代码。最后我们要修改一下 FFmpeg 的内部退出回调对应的函数：</p>
<pre class="prettyprint linenums"><code>// Since we only have one decoding thread, the Big Struct can be global in case we need it.<br />
VideoState *global_video_state;

int decode_interrupt_cb(void *opaque) {<br />
	return (global_video_state &amp;&amp; global_video_state-&gt;quit);<br />
}<br />
</code></pre>
<p>我们在主函数设置 <code>global_video_state</code> 为 <code>VideoState *is</code>。</p>
<p>以上便是我们这节教程的全部内容，其中的完整代码你可以从这里获得：<a href="https://github.com/samirchen/TestFFmpeg" rel="external nofollow noreferrer">https://github.com/samirchen/TestFFmpeg</a></p>
<h2>编译执行</h2>
<p>你可以使用下面的命令编译它：</p>
<pre class="prettyprint linenums"><code>$ gcc -o tutorial04 tutorial04.c -lavutil -lavformat -lavcodec -lswscale -lz -lm `sdl-config --cflags --libs`<br />
</code></pre>
<p>找一个视频文件，你可以这样执行一下试试：</p>
<pre class="prettyprint linenums"><code>$ tutorial04 myvideofile.mp4<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql0v0qo.html">PHP的学习--新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k1le59.html">OpenCV图像的全局阈值二值化函数（OTSU）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm11x09.html">Effective C&plus;&plus; 6&period;继承与面向对象设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmldk9.html">网页自适应&commat;media</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o30dj9.html">委托delegate使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7v209.html">zookeeper实现分布锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm03o49.html">01&lowbar;JavaMail&lowbar;03&lowbar;邮件发送简单实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xz74n9.html">android中广播接收SD卡状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kknv59.html">小说mvvm</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmzzx8.html">java工程打包成jar包，并且解压lib里的jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnxw59.html">启动activity与使用Intent通信机制解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zd5vj9.html">Java设计模式学习笔记，二：工厂模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n5ryq.html">升级node与npm</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ym6v8.html">&lbrack;国嵌攻略&rsqb;&lbrack;159&rsqb;&lbrack;SPI子系统&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1yomyq.html">&period;net momeryStream 读取为空问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj33kk8.html">mysql数据库的基本操作：索引、视图，导入和导出，备份和恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zpxdj9.html">P2921 &lbrack;USACO08DEC&rsqb;在农场万圣节Trick or Treat on the Farm   记忆化搜索dfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2w170q.html">快速入门 WePY 小程序【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv27evz9.html">java基础之继承（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4n4pe9.html">Todolist功能开发</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1vgxjzq.html">golang中context包学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko3e5rq.html">js 高程 函数节流 throttle&lpar;&rpar; 分析与优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/9636rwy9.html">160519、Oracle中将查询出的多条记录的某个字段拼接成一个字符串的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko372rq.html">jstree的checkbox实例&plus;详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnjxr4q.html">Hadoop伪分布安装详解&lpar;三&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvezy2q.html">Exchange Powershell：Get-Counter （List connections to OWA ）</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1zgje9.html">php和jsCOOKIE实现前端交互</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx20pgd8.html">java中日期常用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj6657q.html">python脚本前两行</a>
			</li>
						<li><a href="https://www.batexi.com/a/96mjj7n8.html">JavaWeb-Servlet-通过servlet生成验证码图片</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
